package com.zfire.jiasm.syncdata.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.zfire.jiasm.syncdata.base.BaseService;
import com.zfire.jiasm.syncdata.constant.DictTypeEnum;
import com.zfire.jiasm.syncdata.constant.ServiceCategoryEnum;
import com.zfire.jiasm.syncdata.gree.GreeLogic;
import com.zfire.jiasm.syncdata.helper.GreeResponseHelper;
import com.zfire.jiasm.syncdata.plus.entity.*;
import com.zfire.jiasm.syncdata.plus.service.*;
import com.zfire.jiasm.syncdata.request.SignSplb;
import com.zfire.jiasm.syncdata.request.ZJInfo;
import com.zfire.jiasm.syncdata.request.ZJInfoBX;
import com.zfire.jiasm.syncdata.request.ZJInfoC;
import com.zfire.jiasm.syncdata.response.WangdianWxgVos;
import com.zfire.jiasm.syncdata.response.WxgQueryInfo;
import com.zfire.jiasm.syncdata.service.GLPPWXGQueryAddService;
import com.zfire.jiasm.syncdata.service.PublicService;
import com.zfire.jiasm.syncdata.test;
import com.zfire.jiasm.syncdata.utils.MyBeanUtils;
import com.zfire.jiasm.syncdata.utils.oss.OSSUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.io.File;
import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;


@Slf4j
@Service
public class GLPPWXGQueryAddServiceImpl implements GLPPWXGQueryAddService {
    String wdqyapi = "/outapp/wxg/list";

    @Resource
    BaseService baseService;
    @Resource
    GreeLogic greeLogic;
    @Resource
    OSSUtil ossUtil;
    @Resource
    ItfTblWangdianWxgDownloadService itfTblWangdianWxgDownloadService;
    @Resource
    ItfTblXinWangdianDownloadService itfTblXinWangdianDownloadService;
    @Resource
    WorkerBrandAccountService workerBrandAccountService;
    @Resource
    WorkerCertService workerCertService;
    @Resource
    WorkerStreetService workerStreetService;
    @Resource
    ProvinceService provinceService;
    @Resource
    BrandLbsRelateService brandLbsRelateService;
    @Resource
    WorkerServiceCategoryService workerServiceCategoryService;
    @Resource
    WorkerServiceCategoryDetailService workerServiceCategoryDetailService;
    @Resource
    SysDictRefService sysDictRefService;
    @Resource
    SysDictService sysDictService;
    @Resource
    CustomerInformationWebsitService customerInformationWebsitService;
    @Resource
    WebsitService websitService;
    @Resource
    WorkerService workerService;
    @Resource
    ItfTblWangdianPositionDownloadService itfTblWangdianPositionDownloadService;
    @Resource
    PublicService publicService;
    @Resource
    WebsitWorkerService websitWorkerService;
    @Resource
    InsureWorkerCommercialService insureWorkerCommercialService;
    @Resource
    InsureWorkerCommercialFileService insureWorkerCommercialFileService;
    @Resource
    OrderDetailFileService orderDetailFileService;
    @Resource
    OrderInstallDetailCodeService orderInstallDetailCodeService;



    @Override
    public void extractedCertInfo(){
        WangdianWxgVos wvos = new WangdianWxgVos();
        List<WorkerCert> addList = new ArrayList<>();
        Map<String,Object> req = new HashMap<>();
        Map<String,List<Worker>> workerIdcardMap = new HashMap<>();
        Map<String,List<Worker>> workerWorkeridMap = new HashMap<>();
        Map<String,List<WorkerCert>> WorkerCertWorkerIdMaps = new HashMap<>();
        List<ItfTblWangdianWxgDownload> wxgDownladRecs = new ArrayList<>();
        List<WebsitWorker> websitWorkerUp = new ArrayList<>();
        List<String> workerIdandNames = new ArrayList<>();
        List<InsureWorkerCommercial> insurecs = new ArrayList<>();
        List<InsureWorkerCommercialFile> insurefiles = new ArrayList<>();
        List<String> insureworkeridandWebsitids = new ArrayList<>();
        Map<String,List<WebsitWorker>> websitWorderwidwdidMap = new HashMap<>();

        // 提取品牌信息
        Brand brand = baseService.getBrand();
        if (brand == null) {
            return;
        }

        List<Worker> oldWorkerRec =  workerService.lambdaQuery()
                .select(Worker::getIdcard,Worker::getWorkerId,Worker::getWorkerName,Worker::getMobile).list();
        if (CollectionUtils.isNotEmpty(oldWorkerRec)){
            workerIdcardMap = oldWorkerRec.stream().collect(Collectors.groupingBy(Worker::getIdcard));
            workerWorkeridMap = oldWorkerRec.stream().collect(Collectors.groupingBy(Worker::getWorkerId));
            oldWorkerRec.clear();
        }

        // 提取师傅所有的保险(有效的) 防重复添加
        List<InsureWorkerCommercial> iwcs = insureWorkerCommercialService.lambdaQuery()
                .eq(InsureWorkerCommercial::getStatus,"ON").list();
        if (CollectionUtils.isNotEmpty(iwcs)){
            iwcs.stream().forEach(event->{
                insureworkeridandWebsitids.add(event.getWorkerId()+event.getWebsitId());
            });
            iwcs.clear();
        }

        Insure insure = publicService.getWebsitWorkerByWorkerAndWebsit("意外险");

        List<WebsitWorker> wws = publicService.getWebsitWorkerByWorkerAndWebsit();
        if (CollectionUtils.isNotEmpty(wws)){
            websitWorderwidwdidMap = wws.stream().collect(Collectors.groupingBy(WebsitWorker::getWorkerId));
            wws.clear();
        }

        // 提取格力现有的网点师傅数据信息
        wxgDownladRecs =  itfTblWangdianWxgDownloadService.lambdaQuery()
                .select(ItfTblWangdianWxgDownload::getWxgid,
                        ItfTblWangdianWxgDownload::getWxgno,
                        ItfTblWangdianWxgDownload::getWdno,
                        ItfTblWangdianWxgDownload::getSfzen,
                        ItfTblWangdianWxgDownload::getWxgmc,
                        ItfTblWangdianWxgDownload::getYddh,
                        ItfTblWangdianWxgDownload::getFlag)
                // .eq(ItfTblWangdianWxgDownload::getSfzen,"431003199803271316")// 测试用
                .like(ItfTblWangdianWxgDownload::getWdno,"S%").list();

        // 提取现有已存在的证件信息的师傅信息(待回传同步的证件不处理)
        List<WorkerCert> wc = workerCertService.lambdaQuery()
                .eq(WorkerCert::getOutSyncStatus,1).list();
        if (CollectionUtils.isNotEmpty(wc)){
            WorkerCertWorkerIdMaps = wc.stream().collect(Collectors.groupingBy(WorkerCert::getWorkerId));
            wc.clear();
        }


        for (ItfTblWangdianWxgDownload wxg :wxgDownladRecs){
            // 无效的数据不新增
            if (wxg.getFlag() != null){
                if (!wxg.getFlag().trim().equals(DictTypeEnum.DICT_TYPE_FLAG_ON.getCode())){
                    continue;
                }
            }
            // 平台师傅信息不包含格力总部的数据不处理(包含的为格力的师傅信息同步时已生成了worker)
            // 这里用身份证来做包含关系(测试环境身份证隐藏* 需加名称及手机号)
            String workerId = checkIsGreeWroker(workerIdcardMap, wxg);
            if (workerId.length()<1) {
                continue;
            }

            // 有证件信息的师傅不再新增
            /*if (WorkerCertWorkerIdMaps.containsKey(workerId)){
                continue;
            }*/

            // 参数 获取网点维修工信息
            getParameter(wxg.getWdno(), wxg.getWxgno(), req);

            try {
                // 格力总部查询工程师信息
                GreeResponseHelper response = greeLogic.greePost(wdqyapi, JSONObject.toJSONString(req), publicService.getCompanyId(wxg.getWdno()));
                // 失败不处理
                if (response.getStatus() == 200){
                    WxgQueryInfo resultDatax = JSONObject.parseObject(response.getData().toString(), WxgQueryInfo.class);
                    // 无证件不处理
                    if ( resultDatax.getWangdianWxgVos().size()<1){
                        continue;
                    }

                    wvos = resultDatax.getWangdianWxgVos().get(0);

                    log.info("总部获取的工程师证件照信息wvos:{}", JSONObject.toJSONString(wvos));
                    // 同步-新增证件信息
                    getCertInfo(wvos, addList, workerId, WorkerCertWorkerIdMaps,wxg.getWdno(),workerIdandNames,
                            workerWorkeridMap,insurecs,insurefiles, insureworkeridandWebsitids,websitWorderwidwdidMap, insure);
                    // 新增或修改(证件)
                    addDataCert(addList);
                    // 修改保险信息
                    addBxInfo(insurecs, insurefiles);

                    log.info("工程师证件照信息同步成功-师傅证件信息:{}", wxg.getSfzen());
                } else {
                    log.info("获取工程师证件照信息失败-师傅证件信息:{}", wxg.getSfzen());
                    log.info("msg:{}", response.getMsg());
                }
            } catch (Exception ex) {
                addDataCert(addList);
                upWebsitWorker(websitWorkerUp);
                addBxInfo(insurecs, insurefiles);
                ex.printStackTrace();
                log.info("工程师证件照信息同步失败-师傅证件信息:{}", wxg.getSfzen());
            }
        }

    }

    @Transactional(rollbackFor = Exception.class)
    public void addBxInfo(List<InsureWorkerCommercial> insurecs, List<InsureWorkerCommercialFile> insurefiles) {
        if (insurecs.size()>0){
            insureWorkerCommercialService.saveOrUpdateBatch(insurecs);
            insurecs.clear();
        }
        if (insurefiles.size()>0){
            insureWorkerCommercialFileService.saveOrUpdateBatch(insurefiles);
            insurefiles.clear();
        }
    }


    @Override
    public void extractedCert() {
        List<WorkerCert> workerCertList = new ArrayList<>();
        List<WorkerCert> workerCertUpList = new ArrayList<>();
        // 提取需要处理的证件照数据

        workerCertList = workerCertService.lambdaQuery()
                .eq(WorkerCert::getOutZjljProcess,0)
                // .eq(WorkerCert::getWorkerId,"1696834689558614018")// 测试用
                .isNotNull(WorkerCert::getOutZjlj).list();

        for (WorkerCert item :workerCertList){
            try{
                // 生成图片
                processCertInfo(item);
                workerCertUpList.add(item);
                updateWorkerCertInfo(workerCertUpList, 100);
            } catch (Exception ex) {
                ex.printStackTrace();
                updateWorkerCertInfo(workerCertUpList, 0);
                log.info("生成师傅证件照信息失败worker_cert.id= {}",item.getId());
            }
        }

        updateWorkerCertInfo(workerCertUpList, 0);
    }

    @Override
    public void extractedBx(){
        List<InsureWorkerCommercialFile> iwcfiles = new ArrayList<>();
        List<InsureWorkerCommercialFile> iwcfilesUpList = new ArrayList<>();
        // 提取需要处理的证件照数据

        iwcfiles = insureWorkerCommercialFileService.lambdaQuery()
                .eq(InsureWorkerCommercialFile::getOutZjljProcess,0)
                // .in(InsureWorkerCommercialFile::getId,"1696844130739736578","1696844133302456321","1696844133449256965")// 测试用
                .isNotNull(InsureWorkerCommercialFile::getOutZjlj).list();

        for (InsureWorkerCommercialFile item :iwcfiles){
            try{
                // 生成图片
                processBxInfo(item);
                iwcfilesUpList.add(item);

                updateBxInfo(iwcfilesUpList, 100);
            } catch (Exception ex) {
                ex.printStackTrace();
                updateBxInfo(iwcfilesUpList, 0);
                log.info("生成师傅证件照信息失败worker_cert.id= {}",item.getId());
            }
        }

        updateBxInfo(iwcfilesUpList, 0);
    }

    @Override
    public void extractedMXFile(){
        List<OrderDetailFile> odfiles = new ArrayList<>();
        List<OrderDetailFile> odfilesUpList = new ArrayList<>();

        odfiles = orderDetailFileService.lambdaQuery()
                .eq(OrderDetailFile::getOutZjljProcess,0)
                .isNotNull(OrderDetailFile::getOutPicture).list();

        for (OrderDetailFile item :odfiles){
            try{
                // 生成图片
                processMXFileInfo(item);
                odfilesUpList.add(item);

                updateMXFile(odfilesUpList, 100);
            } catch (Exception ex) {
                ex.printStackTrace();
                updateMXFile(odfilesUpList, 0);
                log.info("生成商户到平台采集图信息失败order_detail_file.id= {}",item.getId());
            }
        }

        updateMXFile(odfilesUpList, 0);
    }


    private void updateWorkerCertInfo(List<WorkerCert> workerCertUpList, int i) {
        if (workerCertUpList.size() > i) {
            workerCertService.updateBatchById(workerCertUpList);
            workerCertUpList.clear();
        }
    }

    private void updateBxInfo(List<InsureWorkerCommercialFile> iwcfilesUpList, int i) {
        if (iwcfilesUpList.size() > i) {
            insureWorkerCommercialFileService.updateBatchById(iwcfilesUpList);
            iwcfilesUpList.clear();
        }
    }

    private void updateMXFile(List<OrderDetailFile> iwcfilesUpList, int i) {
        if (iwcfilesUpList.size() > i) {
            orderDetailFileService.updateBatchById(iwcfilesUpList);
            iwcfilesUpList.clear();
        }
    }

    private void upWebsitWorker(List<WebsitWorker> websitWorkerUp) {
        if (websitWorkerUp.size()>0){
            websitWorkerService.saveOrUpdateBatch(websitWorkerUp);
            websitWorkerUp.clear();
        }
    }

    private String checkIsGreeWroker(Map<String, List<Worker>> workerIdcardMap, ItfTblWangdianWxgDownload wxg) {
        String workerId="";
        if (workerIdcardMap.containsKey(wxg.getSfzen())){
            workerId = workerIdcardMap.get(wxg.getSfzen()).get(0).getWorkerId();
        }
        return workerId;
    }

    @Override
    public void extractedAddCategory() throws Exception {
        List<WorkerBrandAccount> workerBrandAccounts = new ArrayList<>();
        Map<String,List<Worker>> Worker_Idcards = new HashMap<>();
        Map<String, List<WorkerServiceCategoryDetail>> workerServiceCategoryDetailMap = new HashMap<>();
        Map<String, List<SysDictRef>> sysDictRefMap = new HashMap<>();
        List<SysDictRef> sysDictRef = new ArrayList<>();
        List<WorkerServiceCategoryDetail> wxgCategoryRec = new ArrayList<>();
        List<String> workerServiceCategoryDetailList = new ArrayList<>();

        // 提取品牌信息
        Brand brand = baseService.getBrand();
        if (brand == null) {
            return;
        }

        // 提取品牌商对应的大类信息
        sysDictRef =  sysDictRefService.lambdaQuery()
                .select(SysDictRef::getDictCode,SysDictRef::getDictValue,SysDictRef::getRefDictCode)
                .eq(SysDictRef::getBrandId, brand.getBrandId())
                .eq(SysDictRef::getDictType, DictTypeEnum.DICT_TYPE_MAIN_TYPE.getCode())
                .list();
        if (CollectionUtils.isNotEmpty(sysDictRef)){
            sysDictRefMap = sysDictRef.stream().
                    collect(Collectors.groupingBy(SysDictRef::getRefDictCode));
        }

        // 字典表中查出ID 格力只有-家电售后
        SysDict sysDict =  sysDictService.lambdaQuery()
                .eq(SysDict::getDictType, ServiceCategoryEnum.DICT_TYPE_SERVICE_CATEGORY.getCode())
                .eq(SysDict::getDictValue,ServiceCategoryEnum.DICT_TYPE_SERVICE_CATEGORY.getText())
                .last("limit 1")
                .one();
        if (sysDict == null) {
            return;
        }

        List<Worker> oldWorkerRec =  workerService.lambdaQuery()
                .select(Worker::getIdcard,Worker::getWorkerId,Worker::getWorkerName,Worker::getMobile).list();
        if (CollectionUtils.isNotEmpty(oldWorkerRec)){
            Worker_Idcards = oldWorkerRec.stream().collect(Collectors.groupingBy(Worker::getIdcard));
        }

        // 提取格力现有的网点师傅数据信息
        List<ItfTblWangdianWxgDownload> wxgRecs =  itfTblWangdianWxgDownloadService.lambdaQuery()
                .select(ItfTblWangdianWxgDownload::getWxgid,
                        ItfTblWangdianWxgDownload::getWxgno,
                        ItfTblWangdianWxgDownload::getWdno,
                        ItfTblWangdianWxgDownload::getSfzen,
                        ItfTblWangdianWxgDownload::getWxgmc,
                        ItfTblWangdianWxgDownload::getYddh,
                        ItfTblWangdianWxgDownload::getFlag)
                // .eq(ItfTblWangdianWxgDownload::getWxgno,"S21A00200023")// 测试用 todo
                .eq(ItfTblWangdianWxgDownload::getFlag,DictTypeEnum.DICT_TYPE_FLAG_ON.getCode())
                .like(ItfTblWangdianWxgDownload::getWdno,"S%").list();


        //本地提取商户师傅网点信息  商户网点对应平台网点存在一对多关系
        workerBrandAccounts = workerBrandAccountService.lambdaQuery()
                .eq(WorkerBrandAccount::getGroupCompanyId, brand.getBrandId())
                .eq(WorkerBrandAccount::getBrandWorkerStatus,"ON")
                .eq(WorkerBrandAccount::getDel,0)
                .isNotNull(WorkerBrandAccount::getBrandWorkerNumber)
                .isNotNull(WorkerBrandAccount::getBrandWebsitId)
                .list();
        // 这里提取对应的商户网点信息

        // 提取所有师傅的服务大类信息 先内存中查询
        wxgCategoryRec = workerServiceCategoryDetailService.lambdaQuery().list();
        if (CollectionUtils.isNotEmpty(wxgCategoryRec)){
            workerServiceCategoryDetailMap = wxgCategoryRec.stream().collect(Collectors.groupingBy(WorkerServiceCategoryDetail::getWebsitWorkerId));
        }

        for (ItfTblWangdianWxgDownload wxgDownload :wxgRecs){
            log.info("师傅服务类目 a");
            // 状态无效不处理
            if (wxgDownload.getFlag() != null){
                if (!wxgDownload.getFlag().trim().equals(DictTypeEnum.DICT_TYPE_FLAG_ON.getCode())){
                    continue;
                }
            }

            log.info("师傅服务类目 b");
            // 师傅在平台中不存在时不处理
            String workerId = checkIsGreeWroker(Worker_Idcards, wxgDownload);
            if (workerId.length()<1) {
                continue;
            }

            log.info("师傅服务类目 c");
            wxgCategoryQueryAdd(wxgDownload,workerBrandAccounts,workerServiceCategoryDetailMap,sysDict,
                    sysDictRefMap, workerServiceCategoryDetailList);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    public void addData(List<WorkerBrandAccount> wbaaddList, List<WorkerStreet> ws) {
        // 师傅所在品牌商网点信息同步
        if (wbaaddList.size()>0){
            workerBrandAccountService.saveBatch(wbaaddList);
        }

        // 同步-师傅地理位置
        if (ws.size()>0){
            workerStreetService.saveBatch(ws);
        }

        wbaaddList.clear();
        ws.clear();
    }


    @Override
    public void extractedwxgQueryAdd() throws Exception {
        WangdianWxgVos wvos = new WangdianWxgVos();
        List<WorkerBrandAccount> wbaaddList = new ArrayList<>();
        List<WorkerBrandAccount> wbarecs = new ArrayList<>();
        Map<String,Object> req = new HashMap<>();
        List<WorkerStreet> ws = new ArrayList<>();
        Map<String, List<WorkerServiceCategoryDetail>> wxgCategoryTypeRecs = new HashMap<>();

        // 提取品牌信息
        Brand brand = baseService.getBrand();
        if (brand == null) {
            return;
        }

        // 网点对应关系
        List<CustomerInformationWebsit> ciws = customerInformationWebsitService.lambdaQuery()
                .select(CustomerInformationWebsit::getWebsitId,
                        CustomerInformationWebsit::getRefWebsitId).list();
        if (ciws ==null || ciws.size()<1){
            return;
        }

        List<Worker> oldWorkerRec =  workerService.lambdaQuery()
                .select(Worker::getWorkerId).list();
        List<String> oldWorkers = oldWorkerRec.stream().map(Worker::getWorkerId).collect(Collectors.toList());

        // 提取对应的服务商网点信息
        List<Websit> websits = websitService.lambdaQuery()
                .select(Websit::getWebsitId,
                        Websit::getWebsitName)
                .in(Websit::getWebsitId,ciws.stream().map(CustomerInformationWebsit::getWebsitId).collect(Collectors.toList()))
                .list();

        // 提取格力所有的网点信息
        List<ItfTblXinWangdianDownload> wdRecs = itfTblXinWangdianDownloadService.lambdaQuery()
                .select(ItfTblXinWangdianDownload::getPkGuid,
                        ItfTblXinWangdianDownload::getWdno).list();
        Map<String, List<ItfTblXinWangdianDownload>> mapWdRes = wdRecs.stream().
                collect(Collectors.groupingBy(ItfTblXinWangdianDownload::getWdno));

        // 提取格力现有的网点师傅数据信息
        List<ItfTblWangdianWxgDownload> wxgRecs =  itfTblWangdianWxgDownloadService.lambdaQuery()
                .select(ItfTblWangdianWxgDownload::getWxgid,
                        ItfTblWangdianWxgDownload::getWxgno,
                        ItfTblWangdianWxgDownload::getWdno,
                        ItfTblWangdianWxgDownload::getSfzen)
                // .eq(ItfTblWangdianWxgDownload::getWxgno,"S21A00200023")// 测试用 todo
                .like(ItfTblWangdianWxgDownload::getWdno,"S%").list();

        //本地提取商户师傅网点信息
        wbarecs = workerBrandAccountService.lambdaQuery()
                .eq(WorkerBrandAccount::getGroupCompanyId, brand.getBrandId())
                .eq(WorkerBrandAccount::getBrandWorkerStatus,"ON")
                .eq(WorkerBrandAccount::getDel,0)
                .isNotNull(WorkerBrandAccount::getBrandWorkerNumber)
                .isNotNull(WorkerBrandAccount::getBrandWebsitId)
                .list();

        // 提取品牌商对应的大类信息
        List<SysDictRef> sysDictRef =  sysDictRefService.lambdaQuery()
                .select(SysDictRef::getDictCode,SysDictRef::getDictValue,SysDictRef::getRefDictCode)
                .eq(SysDictRef::getBrandId, brand.getBrandId())
                .eq(SysDictRef::getDictType, DictTypeEnum.DICT_TYPE_MAIN_TYPE.getCode())
                .list();
        Map<String, List<SysDictRef>> sysDictRefMap = sysDictRef.stream().
                collect(Collectors.groupingBy(SysDictRef::getRefDictCode));

        // 提取所有师傅的服务大类信息 先内存中查询
        List<WorkerServiceCategoryDetail> wxgCategoryRec = workerServiceCategoryDetailService.lambdaQuery().list();
        Map<String, List<WorkerServiceCategoryDetail>> oldWxgCategoryRecMap = wxgCategoryRec.stream().collect(Collectors.groupingBy(WorkerServiceCategoryDetail::getWorkerId));

        for (ItfTblWangdianWxgDownload wxg :wxgRecs){
            // 无效的数据不新增
            if (wxg.getFlag() != null){
                if (!wxg.getFlag().trim().equals(DictTypeEnum.DICT_TYPE_FLAG_ON.getCode())){
                    continue;
                }
            }
            if (!oldWorkers.contains(wxg.getSfzen())){
                continue;
            }

            // 提取本地商户师傅信息 按品牌，网点，师傅编号  存在对象不处理
            WorkerBrandAccount workerBrandAccount = getWorkerBrandAccountData(wbarecs, wxg);
            if (workerBrandAccount != null) {
                continue;
            }

            // 参数 获取网点维修工信息
            getParameter(wxg.getWdno(), wxg.getWxgno(), req);
            // 格力总部查询工程师信息
            GreeResponseHelper response = greeLogic.greePost(wdqyapi, JSONObject.toJSONString(req), publicService.getCompanyId(wxg.getWdno()));
            if (response.getStatus() == 200){
                WxgQueryInfo resultDatax = JSONObject.parseObject(response.getData().toString(), WxgQueryInfo.class);
                // 无信息不处理
                if ( resultDatax.getWangdianWxgVos().size()<1){
                    continue;
                }

                wvos = resultDatax.getWangdianWxgVos().get(0);

                // 提取师傅的服务大类信息 先内存中查询
                if (oldWxgCategoryRecMap.containsKey(wxg.getSfzen())){
                    wxgCategoryTypeRecs = oldWxgCategoryRecMap.get(wxg.getSfzen()).stream().
                            collect(Collectors.groupingBy(WorkerServiceCategoryDetail::getType));

                } else {
                    List<WorkerServiceCategoryDetail> wxgCategoryRecs = workerServiceCategoryDetailService.lambdaQuery()
                            .eq(WorkerServiceCategoryDetail::getWorkerId, wxg.getSfzen()).list();

                    // 服务类型 INSTALL=安装 REPAIR=维修  DELIVERY=配送
                    wxgCategoryTypeRecs = wxgCategoryRecs.stream().
                            collect(Collectors.groupingBy(WorkerServiceCategoryDetail::getType));
                }

                try {

                    // 生成师傅所在品牌商网点信息
                    if (getwbaInfo(wvos, wbaaddList, brand, ciws, websits, wxg, mapWdRes)) {
                        continue;
                    }

                    // 同步-新增师傅地理位置 生成对象失败不处理
                    if (getwz(wvos, ws, brand, wxg.getSfzen())){
                        continue;
                    }

                    // 新增或修改(证件,师傅地理位置,师傅服务的类目)
                    addData(wbaaddList, ws);

                } catch (Exception ex) {
                    log.info("工程师信息同步失败:{}", ex);
                }
            }
        }
    }


    @Override
    public void extracteWxgQueryAddWXGInfo() throws Exception {
        Map<String,Object> req = new HashMap<>();
        WangdianWxgVos wvos = new WangdianWxgVos();
        List<ItfTblWangdianPositionDownload> wdwxgadd = new ArrayList<>();

        List<Worker> oldWorkerRec =  workerService.lambdaQuery()
                .select(Worker::getWorkerId).list();
        List<String> oldWorkers = oldWorkerRec.stream().map(Worker::getWorkerId).collect(Collectors.toList());

        // 提取格力现有的网点师傅数据信息
        List<ItfTblWangdianWxgDownload> wxgRecs =  itfTblWangdianWxgDownloadService.lambdaQuery()
                .select(ItfTblWangdianWxgDownload::getWxgid,
                        ItfTblWangdianWxgDownload::getWxgno,
                        ItfTblWangdianWxgDownload::getWdno,
                        ItfTblWangdianWxgDownload::getSfzen,
                        ItfTblWangdianWxgDownload::getFlag)
                .like(ItfTblWangdianWxgDownload::getWdno,"S%").list();

        try {
            for (ItfTblWangdianWxgDownload wxg :wxgRecs) {
                // 无效的数据不新增
                if (wxg.getFlag() != null) {
                    if (!wxg.getFlag().trim().equals(DictTypeEnum.DICT_TYPE_FLAG_ON.getCode())) {
                        continue;
                    }
                }

                // 师傅不存在不处理
                if (!oldWorkers.contains(wxg.getSfzen())) {
                    continue;
                }
                // 参数 获取网点维修工信息
                getParameter(wxg.getWdno(), wxg.getWxgno(), req);
                // 格力总部查询工程师信息
                GreeResponseHelper response = greeLogic.greePost(wdqyapi, JSONObject.toJSONString(req), publicService.getCompanyId(wxg.getWdno()));
                if (response.getStatus() == 200) {
                    WxgQueryInfo resultDatax = JSONObject.parseObject(response.getData().toString(), WxgQueryInfo.class);
                    // 无信息不处理
                    if (resultDatax.getWangdianWxgVos().size() < 1) {
                        continue;
                    }
                    wvos = resultDatax.getWangdianWxgVos().get(0);
                    // 新增
                    getwdwxdInfo(wvos, wdwxgadd);
                }
            }
            // 新增
            if (wdwxgadd.size() > 0) {
                itfTblWangdianPositionDownloadService.saveBatch(wdwxgadd);
                wdwxgadd.clear();
            }
        } catch (Exception ex) {
            log.info("同步网点维修工数据信息失败:{}", ex);
        }
    }

    private void getwdwxdInfo(WangdianWxgVos wvos, List<ItfTblWangdianPositionDownload> wdwxgadd) {
        ItfTblWangdianPositionDownload item = new ItfTblWangdianPositionDownload();
        BeanUtils.copyProperties(wvos,item);
        wdwxgadd.add(item);
        if (wdwxgadd.size()>=500){
            itfTblWangdianPositionDownloadService.saveBatch(wdwxgadd);
            wdwxgadd.clear();
        }
    }

    private void addWorkerStreet(WangdianWxgVos wvos, String brandId, List<WorkerStreet> ws, String sfzen) {
        WorkerStreet n = new WorkerStreet();
        n.setId(UUID.randomUUID().toString());
        n.setProvinceId("");
        n.setCityId("");
        n.setAreaId("");
        n.setStreetId("");
        n.setWorkerId(sfzen);
        n.setCreateTime(new Date());
        n.setCreateBy("system");


        // 提取省信息
        if (StringUtils.isNotEmpty(wvos.getSfen())){
            Province province = provinceService.lambdaQuery()
                    .eq(Province::getProvince, wvos.getSfen())
                    .last("limit 1")
                    .one();
            if (province !=null){
                List<BrandLbsRelate> bra = brandLbsRelateService.lambdaQuery()
                        .eq(BrandLbsRelate::getProvinceId,province.getProvinceId())
                        .eq(BrandLbsRelate::getDel,0)
                        .eq(BrandLbsRelate::getBrandId,brandId).list();
                if (bra != null && bra.size()>0){
                    for (BrandLbsRelate br :bra){
                        if (StringUtils.isNotEmpty(br.getLbsProvinceId()) && StringUtils.isEmpty(n.getProvinceId())){
                            n.setProvinceId(br.getLbsProvinceId());
                            n.setProvince(br.getLbsProvinceName());
                        }
                        if (StringUtils.isNotEmpty(br.getLbsCityId()) && StringUtils.isEmpty(n.getCityId())){
                            n.setCityId(br.getLbsCityId());
                            n.setCity(br.getLbsCityName());
                        }
                        if (StringUtils.isNotEmpty(br.getLbsDistrictId()) && StringUtils.isEmpty(n.getAreaId())){
                            n.setAreaId(br.getLbsDistrictId());
                            n.setArea(br.getLbsDistrictName());
                        }
                        if (StringUtils.isNotEmpty(br.getLbsStreetId()) && StringUtils.isEmpty(n.getStreetId())){
                            n.setStreet(br.getLbsStreetId());
                            n.setStreetId(br.getLbsStreetName());
                            break;
                        }
                    }
                    ws.add(n);
                }
            }
        }
    }

    private Boolean getwz(WangdianWxgVos wvos, List<WorkerStreet> ws, Brand brand, String sfzen) {
        // 师傅省市区街道信息
        List<WorkerStreet> wsOld = workerStreetService.lambdaQuery()
                .eq(WorkerStreet::getWorkerId, sfzen).list();
        // 不存在新增
        if (wsOld ==null || wsOld.size()<1){
            addWorkerStreet(wvos, brand.getBrandId(), ws,sfzen);
            if (ws.size()<1){
                return Boolean.TRUE;
            }
        }
        return Boolean.FALSE;
    }


    private boolean getwbaInfo(WangdianWxgVos wvos, List<WorkerBrandAccount> wbaaddList, Brand brand,
                               List<CustomerInformationWebsit> ciws, List<Websit> websits,
                               ItfTblWangdianWxgDownload wxg, Map<String, List<ItfTblXinWangdianDownload>> mapWdRes) {
        String websitId ="";
        String websitName ="";

        // 品牌网点与商户网点对关系表中提取品牌方的网点信息  无数据不处理，对应关系需要人为操作
        for (CustomerInformationWebsit wd: ciws){
            if (wd.getRefWebsitId().equals(wxg.getWdno())){
                websitId=wd.getWebsitId();
            }
        }
        if (StringUtils.isEmpty(websitId)){
            return true;
        }

        for (Websit wets: websits){
            if (wets.getWebsitId().equals(websitId)){
                websitName = wets.getWebsitName();
                break;
            }
        }

        // 新增 WorkerBrandAccount todo
        WorkerBrandAccount n = new WorkerBrandAccount();
        n.setId(IdWorker.getIdStr());
        // n.setWorkerId(wxg.getSfzen());
        n.setWebsitId(websitId);
        n.setWebsitName(websitName);
        n.setGroupCompanyId(brand.getBrandId());
        n.setBrandWorkerId(String.valueOf(wxg.getWxgid()));
        n.setBrandWorkerNumber(wxg.getWxgno());
        if (mapWdRes.get(wxg.getWdno()).size()>0){
            n.setBrandWebsitName(mapWdRes.get(wxg.getWdno()).get(0).getWdmc());
        }
        n.setBrandWebsitId(wxg.getWdno());
        n.setBrandWorkerStatus("ON");
        if (wvos.getFlag().equals("无效")){
            n.setBrandWorkerStatus("OFF");
        }
        n.setExpireTime(new Date());
        n.setCreateTime(new Date());
        n.setCreateBy("system");
        wbaaddList.add(n);
        return false;
    }

    public void addDataCert(List<WorkerCert> addList) {
        // 证件同步
        if (addList.size()>0){
            workerCertService.saveOrUpdateBatch(addList);
            addList.clear();
        }
    }

    private String putCert(String image) throws IOException {
        String fileId = "";
        String id = publicService.path(image);
        File newFile = publicService.createf(id);

        try{
            baseService.saveToFile(greeLogic.greeFileUrl(image), newFile);
            ossUtil.uploadFile(id, newFile);
            fileId = id;
            return fileId;
        } catch (Exception ex) {
            ex.printStackTrace();
            log.info("生成师傅证件照信息失败");
        }
        return fileId;
    }

    private void workerBXAdd(ZJInfoBX bx, List<WebsitWorker> websitWorkerUp) throws Exception {
        ZJInfo zj = new ZJInfo();
        zj=bx.getZjInfo();

        // 保单号+名称
        if (zj.getZjbh().contains("/")){
            List<String> result = Arrays.asList(zj.getZjbh().split("/"));
            bx.getWebsitWorker().setSafeCompany(result.get(0));
            bx.getWebsitWorker().setSafeNo(result.get(1));
        } else {
            bx.getWebsitWorker().setSafeNo(zj.getZjbh());
        }

        // 有效期
        if (StringUtils.isNotEmpty(zj.getZjyxq())){
            bx.getWebsitWorker().setGmbxyxq(baseService.utcToDateStr(zj.getZjyxq()));
        }

        // 保险照
        String id = putCert(zj.getZjlj());
        if (StringUtils.isNotEmpty(id)){
            bx.getWebsitWorker().setOutInsureCert(id);
        }
        new File(id).delete();

        websitWorkerUp.add(bx.getWebsitWorker());
    }

    private void workercertAdd(WangdianWxgVos wvos, List<WorkerCert> addList, String workerId,
                               ZJInfoC zjinfo, String workerName) throws Exception {
        ZJInfo zj = new ZJInfo();
        zj=zjinfo.getZjInfo();

        // 新增
        WorkerCert add = new WorkerCert();
        if (zjinfo.getWorkerCert() !=null){
            MyBeanUtils.copyProperties(zjinfo.getWorkerCert(),add);
        } else {
            setAdd(wvos, workerId, workerName, zj, add);
        }

        if (zj.getZjlj().contains(",")){
            List<String> result = Arrays.asList(zj.getZjlj().split(","));
            // 上传图片
            String id = putCert(result.get(0));
            if (StringUtils.isNotEmpty(id)){
                add.setFileUrl(id);
                add.setOutFileUrl(result.get(0));
            }

            String id2 = putCert(result.get(1));
            if (StringUtils.isNotEmpty(id2)){
                add.setFileUrl2(id2);
                add.setOutFileUrl2(result.get(1));
            }
            new File(id).delete();
            new File(id2).delete();
        } else {
            String id = putCert(zj.getZjlj());
            if (StringUtils.isNotEmpty(id)){
                add.setFileUrl(id);
                add.setOutFileUrl(zj.getZjlj());
            }
            new File(id).delete();
        }
        addList.add(add);
    }


    private void processCertInfo(WorkerCert workerCert) throws Exception {
        if (workerCert.getOutZjlj().contains(",")){
            Boolean flag = Boolean.TRUE;
            List<String> result = Arrays.asList(workerCert.getOutZjlj().split(","));
            // 上传图片
            if (StringUtils.isNotEmpty(result.get(0)) && StringUtils.isEmpty(workerCert.getFileUrl())){
                String id = putCert(result.get(0));
                if (StringUtils.isNotEmpty(id)){
                    workerCert.setFileUrl(id);
                    workerCert.setOutFileUrl(result.get(0));
                    new File(id).delete();
                } else {
                    flag = Boolean.FALSE;
                }
            }
            if (StringUtils.isNotEmpty(result.get(1)) && StringUtils.isEmpty(workerCert.getFileUrl2())){
                String id2 = putCert(result.get(1));
                if (StringUtils.isNotEmpty(id2)){
                    workerCert.setFileUrl2(id2);
                    workerCert.setOutFileUrl2(result.get(1));
                    new File(id2).delete();
                } else {
                    flag = Boolean.FALSE;
                }
            }

            if (flag){
                workerCert.setOutZjljProcess(1);
            }
            workerCert.setOutSyncTime(new Date());
        } else {
            if (StringUtils.isNotEmpty(workerCert.getOutZjlj())){
                String id = putCert(workerCert.getOutZjlj());
                if (StringUtils.isNotEmpty(id)){
                    workerCert.setFileUrl(id);
                    workerCert.setOutFileUrl(workerCert.getOutZjlj());
                    workerCert.setOutZjljProcess(1);
                    workerCert.setOutSyncTime(new Date());
                    new File(id).delete();
                }
            }
        }
    }

    private void processBxInfo(InsureWorkerCommercialFile iwcfile) throws IOException {
        if (StringUtils.isNotEmpty(iwcfile.getOutZjlj()) && StringUtils.isEmpty(iwcfile.getFileUrl())){
            String id = putCert(iwcfile.getOutZjlj());
            if (StringUtils.isNotEmpty(id)){
                iwcfile.setFileUrl(id);
                iwcfile.setOutZjljProcess(1);
                iwcfile.setCreateTime(new Date());
                new File(id).delete();
            }
        } else {
            iwcfile.setOutZjljProcess(1);
            iwcfile.setCreateTime(new Date());
        }
    }

    private void processMXFileInfo(OrderDetailFile iwcfile) throws IOException {
        if (StringUtils.isNotEmpty(iwcfile.getOutPicture())){
            String id = putCert(iwcfile.getOutPicture());
            if (StringUtils.isNotEmpty(id)){
                iwcfile.setFilePath(id);
                iwcfile.setBrandFilePath(iwcfile.getOutPicture());
                iwcfile.setOutZjljProcess(1);
                iwcfile.setCreateTime(new Date());
                new File(id).delete();
            }

        }
    }

    private void setAdd(WangdianWxgVos wvos, String workerId, String workerName, ZJInfo zj, WorkerCert add) throws ParseException {
        add.setId(UUID.randomUUID().toString());
        add.setWorkerId(workerId);
        add.setCertName(zj.getZjmc().trim());
        add.setName(workerName);


        if (zj.getZjbh().contains("/")){
            List<String> result = Arrays.asList(zj.getZjbh().split("/"));
            add.setCertNo(result.get(1));
        } else {
            add.setCertNo(zj.getZjbh());
        }
        if (StringUtils.isNotEmpty(zj.getZjyxq())){
            add.setExpireTime(baseService.utcToDateStr(zj.getZjyxq()));
        }
        if (StringUtils.isNotEmpty(zj.getZjfssj())){
            add.setReviewTime(baseService.utcToDateStr(zj.getZjfssj()));
        }
        add.setExamineStatus("OK");
        add.setSex(wvos.getXingb());
        add.setOutSyncStatus(1);
        add.setOutSyncTime(new Date());
    }


    private void getCertInfobak(WangdianWxgVos wvos, List<WorkerCert> addList, String workerId,
                             String workerName, Map<String,List<WorkerCert>> WorkerCertWorkerIdMaps,
                             List<WebsitWorker> websitWorkerUp,String wdno,
                             Map<String,List<WebsitWorker>> websitWorkerWorkerIdMap) throws Exception {
        // 同步-新增证件信息
        for (ZJInfo zj: wvos.getZjInfoList()){
            // 保险证单独处理 只有修改无需新增操作
            // websit.category_type决定保险类型 自建+不为商用(家用)其他商用
            // 家用 insure_worker_record
            // 商用 insure_worker_commercial 商用才操作，最有效期最后的那个
            // websit_worker


                if (zj.getZjmc().trim().equals("保险证")){
                    ZJInfoBX bx = checkBxCertInfo(workerId, websitWorkerWorkerIdMap,zj, wdno);
                    if (bx == null){
                        continue;
                    }
                    workerBXAdd(bx, websitWorkerUp);
                    continue;
                }
            // 校验证件是否需要新增同步
            ZJInfoC addZj =checkCertInfo(workerId,WorkerCertWorkerIdMaps,zj);
            if (addZj.getZjInfo()!=null){
                workercertAdd(wvos, addList, workerId, addZj, workerName);
            }
        }
    }


    private void getCertInfo(WangdianWxgVos wvos, List<WorkerCert> addList, String workerId,
                             Map<String,List<WorkerCert>> WorkerCertWorkerIdMaps,
                             String wdno, List<String> workerIdandNames,Map<String,List<Worker>> workerWorkeridMap,
                             List<InsureWorkerCommercial> insurecs,
                             List<InsureWorkerCommercialFile> insurefiles,
                             List<String> insureworkeridandWebsitids,
                             Map<String,List<WebsitWorker>> websitWorderwidwdidMap, Insure insure) throws ParseException {
        // 同步-新增证件信息
        for (ZJInfo zj: wvos.getZjInfoList()){
            // 保除证
            if (zj.getZjmc().trim().equals("保险证")){
                if (insure == null){
                    continue;
                }
                if (produceBXInfo(workerId, wdno, workerWorkeridMap, insurecs, insurefiles,
                        insureworkeridandWebsitids, zj,websitWorderwidwdidMap, insure)){
                    continue;
                }

                continue;
            }

            // 生成其他证件信息
            produceCert(wvos, addList, workerId, WorkerCertWorkerIdMaps, workerIdandNames, workerWorkeridMap, zj);
        }
    }

    private void produceCert(WangdianWxgVos wvos, List<WorkerCert> addList, String workerId, Map<String,
            List<WorkerCert>> WorkerCertWorkerIdMaps, List<String> workerIdandNames,
                             Map<String, List<Worker>> workerWorkeridMap, ZJInfo zj) throws ParseException {
        Boolean addFlag = Boolean.FALSE;

        // workerid+证件名称锁定不重复
        if (workerIdandNames.contains(workerId + zj.getZjmc().trim())){
            return;
        }

        // 历史数据存在不新增
        if (WorkerCertWorkerIdMaps.containsKey(workerId)){
            for (WorkerCert item: WorkerCertWorkerIdMaps.get(workerId)){
                // 名称相同 即表中已存在，不新增
                if (item.getCertName().equals(zj.getZjmc().trim())){
                    addFlag = Boolean.TRUE;
                    break;
                }
            }
        }
        if (addFlag){
            return;
        }
        // 新增
        addNewWorkerCert(wvos, addList, workerId, workerWorkeridMap.get(workerId).get(0).getWorkerName(), workerIdandNames, zj);
    }

    /**
     * 保险证单独处理 只有修改无需新增操作
     * websit.category_type决定保险类型 自建+不为商用(家用)其他商用
     * 家用 insure_worker_record
     * 商用 insure_worker_commercial 商用才操作，最有效期最后的那个
     * websit_worker
     *
     * 统一入商用保险，有多少份入多少份
     */
    private boolean produceBXInfo(String workerId, String wdno, Map<String, List<Worker>> workerWorkeridMap,
                                  List<InsureWorkerCommercial> insurecs, List<InsureWorkerCommercialFile> insurefiles,
                                  List<String> insureworkeridandWebsitids, ZJInfo zj,
                                  Map<String, List<WebsitWorker>> websitWorderwidwdidMap, Insure insure) throws ParseException {
        // 提取商户售后网点对应的平台售后网点信息 存在一对多的关系 无对应关系退出不处理
        List<WebsitOrderSign> wos = publicService.shShwdToptshwdByBrandWebsitNo(wdno);
        if (CollectionUtils.isEmpty(wos)){
            return true;
        }

        // 生成商用保险对像 网点多对1时每个网点放一份
        for (WebsitOrderSign item : wos){
            // 防重
            if (insureworkeridandWebsitids.contains(workerId +item.getWebsitId())){
                continue;
            }

            // 对于在商户网点师傅都为无效的状态时在平台网点师傅表中可能是不存在的 需要排除掉
            String websitWorkerId = checkWebsitWorker(workerId, websitWorderwidwdidMap, item);
            if (websitWorkerId == null) {
                continue;
            }

            // 生成商用保险对像
            InsureWorkerCommercial a = getInsureWorkerCommercial(workerId, workerWorkeridMap, insurecs, zj, item,websitWorkerId, insure);

            // 生成附件对像
            getInsureWorkerCommercialFile(insurefiles, zj, a);

            insureworkeridandWebsitids.add(workerId +item.getWebsitId());
        }
        return false;
    }

    @Nullable
    private String checkWebsitWorker(String workerId, Map<String, List<WebsitWorker>> websitWorderwidwdidMap, WebsitOrderSign item) {
        String websitWorkerId="";
        if (!websitWorderwidwdidMap.containsKey(workerId)){
            return null;
        }
        // 提取 websitWorkerId
        for (WebsitWorker w : websitWorderwidwdidMap.get(workerId)){
            if (w.getWebsitId().equals(item.getWebsitId())){
                websitWorkerId=w.getWebsitWorkerId();
                break;
            }
        }
        if (StringUtils.isEmpty(websitWorkerId)){
            return null;
        }
        return websitWorkerId;
    }

    @NotNull
    private InsureWorkerCommercial getInsureWorkerCommercial(String workerId, Map<String, List<Worker>> workerWorkeridMap,
                                                             List<InsureWorkerCommercial> insurecs, ZJInfo zj,
                                                             WebsitOrderSign item, String websitWorkerId, Insure insure) throws ParseException {
        InsureWorkerCommercial a = new InsureWorkerCommercial();
        a.setId(IdWorker.getIdStr());
        a.setWorkerId(workerId);
        a.setWorkerName(workerWorkeridMap.get(workerId).get(0).getWorkerName());
        a.setWorkerMobile(workerWorkeridMap.get(workerId).get(0).getMobile());
        a.setWebsitId(item.getWebsitId());
        a.setWebsitWorkerId(websitWorkerId);
        a.setIdcard(workerWorkeridMap.get(workerId).get(0).getIdcard());
        if (StringUtils.isNotEmpty(zj.getZjyxq())){
            a.setStartTime(publicService.subOneYear(baseService.utcToDateStr(zj.getZjyxq())));
            a.setEndTime(baseService.utcToDateStr(zj.getZjyxq()));
        }
        a.setExamineStatus("OK");

        if (insure !=null){
            a.setInsureBill(insure.getId());
            a.setInsureName(insure.getName());
        } else {
            if (zj.getZjbh().contains("/")){
                List<String> result = Arrays.asList(zj.getZjbh().split("/"));
                a.setInsureName(result.get(0));
                a.setInsureBill(result.get(1));
            } else {
                a.setInsureBill(zj.getZjbh());
            }
        }
        insurecs.add(a);
        return a;
    }

    private void getInsureWorkerCommercialFile(List<InsureWorkerCommercialFile> insurefiles, ZJInfo zj, InsureWorkerCommercial a) {
        List<String> zjs = new ArrayList<>();
        if (StringUtils.isEmpty(zj.getZjlj())){
            InsureWorkerCommercialFile icf = new InsureWorkerCommercialFile();
            icf.setId(IdWorker.getIdStr());
            icf.setInsureWorkerCommercialId(a.getId());
            icf.setCreateBy("system");
            icf.setCreateTime(new Date());
            icf.setOutZjlj("");
            icf.setOutZjljProcess(-1);
            insurefiles.add(icf);
            return;
        }

        if (zj.getZjlj().contains(",")){
            zjs = Arrays.asList(zj.getZjlj().split(","));
        } else {
            zjs.add(zj.getZjlj());
        }
        for (String fileurl:zjs){
            InsureWorkerCommercialFile icf = new InsureWorkerCommercialFile();
            icf.setId(IdWorker.getIdStr());
            icf.setInsureWorkerCommercialId(a.getId());
            icf.setCreateBy("system");
            icf.setCreateTime(new Date());
            icf.setOutZjlj(fileurl);
            insurefiles.add(icf);
        }
    }

    private void addNewWorkerCert(WangdianWxgVos wvos, List<WorkerCert> addList, String workerId, String workerName,
                                  List<String> workerIdandNames, ZJInfo zj) throws ParseException {
        WorkerCert add = new WorkerCert();
        add.setId(UUID.randomUUID().toString());
        add.setWorkerId(workerId);
        add.setCertName(zj.getZjmc().trim());
        add.setName(workerName);
        if (StringUtils.isNotEmpty(zj.getZjlj())){
            add.setOutZjlj(zj.getZjlj());
        } else {
            add.setOutZjljProcess(-1);
        }

        if (zj.getZjbh().contains("/")){
            List<String> result = Arrays.asList(zj.getZjbh().split("/"));
            add.setCertNo(result.get(1));
        } else {
            add.setCertNo(zj.getZjbh());
        }
        if (StringUtils.isNotEmpty(zj.getZjyxq())){
            add.setStartTime(publicService.subOneYear(baseService.utcToDateStr(zj.getZjyxq())));
            add.setExpireTime(baseService.utcToDateStr(zj.getZjyxq()));
        }
        if (StringUtils.isNotEmpty(zj.getZjfssj())){
            add.setReviewTime(baseService.utcToDateStr(zj.getZjfssj()));
        }
        add.setExamineStatus("OK");
        add.setSex(wvos.getXingb());
        add.setOutSyncStatus(1);
        add.setOutSyncTime(new Date());
        addList.add(add);
        workerIdandNames.add(workerId + zj.getZjmc().trim());
    }

    // 返回null时不处理
    private ZJInfoBX checkBxCertInfo(String workerId, Map<String,List<WebsitWorker>> websitWorkerWorkerIdMap,
                                     ZJInfo zj, String wdno) {
        ZJInfo resultZjinfo = new ZJInfo();
        ZJInfoBX zjinfo = new ZJInfoBX();
        Map<String,List<WebsitOrderSign>> wosWebsitidMap = new HashMap<>();
        WebsitWorker item = new WebsitWorker();

        // 装入总部同步的保险数据
        zjinfo.setZjInfo(zj);

        // 提取商户售后网点对应的平台售后网点信息 存在一对多的关系
        List<WebsitOrderSign> wos = publicService.shShwdToptshwdByBrandWebsitNo(wdno);
        // 找不到对应关系时不再处理保险证数据
        if (CollectionUtils.isEmpty(wos)){
            return null;
        }
        wosWebsitidMap = wos.stream().collect(Collectors.groupingBy(WebsitOrderSign::getWebsitId));
        wos.clear();

        // 找出师傅所在网点的保险证记录数据
        Boolean flag = Boolean.TRUE;
        for (WebsitWorker i:websitWorkerWorkerIdMap.get(workerId)){
            if (wosWebsitidMap.containsKey(i.getWebsitId())){
                MyBeanUtils.copyProperties(i,item);
                flag = Boolean.FALSE;
                break;
            }
        }

        // 无保险记录时也不需要处理，这里不用关心记录的事，网点服务人员下载时已生成了数据
        if (flag){
            return null;
        }

        // 有保险数据不处理
        if (StringUtils.isNotEmpty(item.getOutInsureCert())){
            return null;
        }

        //取保险记录
        zjinfo.setWebsitWorker(item);

        if (zj.getZjlj().contains(",")){
            List<String> result = Arrays.asList(zj.getZjlj().split(","));
            MyBeanUtils.copyProperties(zj,resultZjinfo);
            resultZjinfo.setZjlj(result.get(0));
            zjinfo.setZjInfo(resultZjinfo);
        }

        return zjinfo;
    }

    private ZJInfoC checkCertInfo(String workerId,Map<String,List<WorkerCert>> WorkerCertWorkerIdMaps,ZJInfo zj) {
        ZJInfo resultZjinfo = new ZJInfo();
        ZJInfoC zjinfo = new ZJInfoC();

        zjinfo.setZjInfo(zj);

        // 不存在时直接新增
        if (!WorkerCertWorkerIdMaps.containsKey(workerId)){
            return zjinfo;
        }

        // 已有证件信息，看是否已全部同步(相同证件名且证件照不为空)
        for (WorkerCert item:WorkerCertWorkerIdMaps.get(workerId)){
            // 名称相同 即表中已存在，只能是修改
            if (item.getCertName().equals(zj.getZjmc())){
                zjinfo.setWorkerCert(item);
                //证件信息不为空不处理
                // 两个证件照时
                if (zj.getZjlj().contains(",")){
                    // 都存在该证件照不同步
                    if (StringUtils.isNotEmpty(item.getFileUrl()) && StringUtils.isNotEmpty(item.getFileUrl2())){
                        zjinfo.setZjInfo(null);
                        return zjinfo;
                    }
                    List<String> result = Arrays.asList(zj.getZjlj().split(","));
                    // 未同步时直接返回新增
                    if (StringUtils.isEmpty(item.getFileUrl()) && StringUtils.isEmpty(item.getFileUrl2())){
                        zjinfo.setZjInfo(zj);
                        return zjinfo;
                    }
                    // 只有一个未同步时新增也是修改
                    MyBeanUtils.copyProperties(zj,resultZjinfo);
                    resultZjinfo.setZjlj(result.get(0));
                    if (StringUtils.isEmpty(item.getFileUrl2())){
                        resultZjinfo.setZjlj(result.get(1));
                    }
                    zjinfo.setZjInfo(resultZjinfo);
                    return zjinfo;
                }
                // 只有一个证件时 已同步不处理
                if (StringUtils.isNotEmpty(item.getFileUrl())){
                    zjinfo.setZjInfo(null);
                    return zjinfo;
                }

                return zjinfo;
            }
        }

        zjinfo.setWorkerCert(null);

        return zjinfo;
    }

    @Transactional(rollbackFor = Exception.class)
    public void wxgCategoryQueryAdd(ItfTblWangdianWxgDownload wxgDownload,
                                    List<WorkerBrandAccount> workerBrandAccounts,
                                    Map<String,List<WorkerServiceCategoryDetail>> workerServiceCategoryDetailMap,
                                    SysDict sysDict,Map<String, List<SysDictRef>> sysDictRefMap,
                                    List<String> workerServiceCategoryDetailList) throws Exception {
        Map<String,Object> req = new HashMap<>();
        WangdianWxgVos wvos = new WangdianWxgVos();
        Map<String, List<WorkerServiceCategoryDetail>> wxgCategoryTypeRecs = new HashMap<>();
        List<WorkerServiceCategory> wscList = new ArrayList<>();
        List<WorkerServiceCategoryDetail> wscdList = new ArrayList<>();

        for (WorkerBrandAccount i:workerBrandAccounts){

            log.info("师傅服务类目 d");
            // 提取本地商户师傅信息 网点｜师傅编号不存在不处理 修改处已做了处理 这里只新增(前提是找到师傅所在网点信息)
            WorkerBrandAccount workerBrandAccount = getWorkerBrandAccountData(workerBrandAccounts, wxgDownload);
            if (workerBrandAccount == null){
                continue;
            }

            log.info("师傅服务类目 e");
            // 师傅对应的网点服务类目信息已存在不处理 只做插入
            if (workerServiceCategoryDetailMap.containsKey(workerBrandAccount.getWebsitWorkerId())){
                continue;
            }

            log.info("师傅服务类目 f");
            // 师傅对应的网点服务类目信息已存在不处理 只做插入
            if (workerServiceCategoryDetailList.contains(workerBrandAccount.getWebsitWorkerId())){
                log.info("只做新增 ");
                continue;
            }

            log.info("师傅信息 {}",JSONObject.toJSONString(i));


            // 参数 获取网点维修工信息
            getParameter(wxgDownload.getWdno(), wxgDownload.getWxgno(), req);
            try {
                // 格力总部查询工程师信息
                GreeResponseHelper response = greeLogic.greePost(wdqyapi, JSONObject.toJSONString(req), publicService.getCompanyId(wxgDownload.getWdno()));

                log.info("师傅信息查询结果 {}",JSONObject.toJSONString(response));

                if (response.getStatus() == 200){
                    WxgQueryInfo resultDatax = JSONObject.parseObject(response.getData().toString(), WxgQueryInfo.class);
                    // 无信息不处理
                    if ( resultDatax.getWangdianWxgVos().size()<1){
                        continue;
                    }

                    wvos = resultDatax.getWangdianWxgVos().get(0);

                    // 提取师傅的服务大类信息 先内存中查询
                    if (workerServiceCategoryDetailMap.containsKey(wxgDownload.getWxgid())){
                        wxgCategoryTypeRecs = workerServiceCategoryDetailMap.get(workerBrandAccount.getWebsitWorkerId()).stream().
                                collect(Collectors.groupingBy(WorkerServiceCategoryDetail::getType));
                    } else {
                        List<WorkerServiceCategoryDetail> wxgCategoryRecs = workerServiceCategoryDetailService.lambdaQuery()
                                .eq(WorkerServiceCategoryDetail::getWebsitWorkerId, workerBrandAccount.getWebsitWorkerId()).list();

                        // 服务类型 INSTALL=安装 REPAIR=维修  DELIVERY=配送
                        if (CollectionUtils.isNotEmpty(wxgCategoryRecs)){
                            wxgCategoryTypeRecs = wxgCategoryRecs.stream().
                                    collect(Collectors.groupingBy(WorkerServiceCategoryDetail::getType));
                        }
                    }

                    // 同步-师傅服务的类目信息 无则插入
                    getServiceCategory(wvos, wscList, wscdList, sysDict, wxgDownload, wxgCategoryTypeRecs,
                            sysDictRefMap, workerBrandAccount, workerServiceCategoryDetailList);

                    log.info("本次新增的服务类目 {}",JSONObject.toJSONString(workerServiceCategoryDetailList));

                    log.info("师傅服务类目 {}",JSONObject.toJSONString(wscList));
                    log.info("师傅服务类别 {}",JSONObject.toJSONString(wscdList));

                    // 新增或修改(师傅服务的类目)
                    addDataCategory(wscList, wscdList);

                    // 清理缓存，把新增的服务类目加到缓存中
                    extractedCaretory(wscList, wscdList, workerServiceCategoryDetailMap, workerBrandAccount);
                }  else {
                    log.info("工程师信息同步失败:{}", JSONObject.toJSONString(req));
                    log.info("msg:{}", response.getMsg());
                }
            } catch (Exception ex) {
                log.info("工程师信息同步失败:{}", ex);
            }

        }
    }

    private void extractedCaretory(List<WorkerServiceCategory> wscList, List<WorkerServiceCategoryDetail> wscdList,
                                   Map<String, List<WorkerServiceCategoryDetail>> oldWxgCategoryRecMap, WorkerBrandAccount workerBrandAccount) {
        if (!oldWxgCategoryRecMap.containsKey(workerBrandAccount.getWebsitWorkerId())){
            oldWxgCategoryRecMap.put(workerBrandAccount.getWebsitWorkerId(),wscdList);
        }

        wscList.clear();
        wscdList.clear();
    }

    public void addDataCategory(List<WorkerServiceCategory> wscList, List<WorkerServiceCategoryDetail> wscdList) {

        // 师傅服务类目新增
        if (wscList.size()>0){
            workerServiceCategoryService.saveBatch(wscList);
            wscList.clear();
        }
        if (wscdList.size()>0){
            workerServiceCategoryDetailService.saveBatch(wscdList);
            wscdList.clear();
        }
    }


    private void getServiceCategory(WangdianWxgVos wvos, List<WorkerServiceCategory> wscList, List<WorkerServiceCategoryDetail> wscdList,
                                    SysDict sysDict, ItfTblWangdianWxgDownload wxg,
                                    Map<String,List<WorkerServiceCategoryDetail>> wxgCategoryTypeRecs,
                                    Map<String, List<SysDictRef>> sysDictRefMap,WorkerBrandAccount workerBrandAccount,
                                    List<String> workerServiceCategoryDetailList) {
        List<String> complete = new ArrayList<>();
        // 先处理商用
        for (SignSplb syitem: wvos.getSySignSplbList()){
            // 扫描每个大类
            for (String s :syitem.getFwlbList()){
                // 师傅服务的大类中查看是否存在 不存在新增
                extracted(wscList, wscdList, complete, sysDict, wxg, wxgCategoryTypeRecs,
                        syitem, s, ServiceCategoryEnum.COMMERCIAL_TYPE.getCode(), sysDictRefMap,
                        workerBrandAccount, workerServiceCategoryDetailList);
            }
        }
        complete.clear();

        // 处理家用
        for (SignSplb syitem: wvos.getJySignSplbList()){
            // 扫描每个大类
            for (String s :syitem.getFwlbList()){
                // 师傅服务的大类中查看是否存在 不存在新增
                extracted(wscList, wscdList, complete, sysDict, wxg, wxgCategoryTypeRecs,
                        syitem, s,ServiceCategoryEnum.HOME_TYPE.getCode(), sysDictRefMap,
                        workerBrandAccount, workerServiceCategoryDetailList);
            }
        }
    }

    private void getParameter(String wdno, String wxgno, Map<String, Object> req) {
        req.put("wdno", wdno);
        req.put("wxgno", wxgno);
        req.put("page", 1);
        req.put("size", 20);
        req.put("xsgsshstat", 2);
    }

    private WorkerBrandAccount getWorkerBrandAccountData(List<WorkerBrandAccount> wbarecs, ItfTblWangdianWxgDownload wxg){
        WorkerBrandAccount workerBrandAccount = null;

        for (WorkerBrandAccount wba: wbarecs){
            if (wba.getBrandWorkerId().equals(wxg.getWxgid())){
                workerBrandAccount = wba;
                break;
            }
        }

        return workerBrandAccount;
    }


    private void extracted(List<WorkerServiceCategory> wscList, List<WorkerServiceCategoryDetail> wscdList,
                           List<String> complete, SysDict sysDict, ItfTblWangdianWxgDownload wxg,
                           Map<String,List<WorkerServiceCategoryDetail>> wxgCategoryTypeRecs, SignSplb syitem,
                           String s, String type,Map<String, List<SysDictRef>> sysDictRefMap,
                           WorkerBrandAccount workerBrandAccount, List<String> workerServiceCategoryDetailList) {
        if ( !complete.contains(s + syitem.getSpdl())){
            // 提取品牌商对应的大类信息
            SysDictRef sysDictRef = sysDictRefMap.get(String.valueOf(syitem.getSpdl())).get(0);

            if (s.equals(ServiceCategoryEnum.INSTALL_TYPE.getText())){
                getAddInfo(wscList, wscdList, sysDict, wxg, wxgCategoryTypeRecs,
                        sysDictRef,ServiceCategoryEnum.INSTALL_TYPE.getCode(),
                        type,workerBrandAccount,workerServiceCategoryDetailList);
            } else if (s.equals(ServiceCategoryEnum.REPAIR_TYPE.getText())){
                getAddInfo(wscList, wscdList, sysDict, wxg, wxgCategoryTypeRecs,
                        sysDictRef,ServiceCategoryEnum.REPAIR_TYPE.getCode(),
                        type,workerBrandAccount,workerServiceCategoryDetailList);
            } else if (s.equals(ServiceCategoryEnum.DELIVERY_TYPE.getText())){
                getAddInfo(wscList, wscdList, sysDict, wxg, wxgCategoryTypeRecs,
                        sysDictRef,ServiceCategoryEnum.DELIVERY_TYPE.getCode(),
                        type,workerBrandAccount,workerServiceCategoryDetailList);
            }
            // 新增过的无需再次新增
            complete.add(s + syitem.getSpdl());
        }
    }

    private void getAddInfo(List<WorkerServiceCategory> wscList, List<WorkerServiceCategoryDetail> wscdList, SysDict sysDict,
                            ItfTblWangdianWxgDownload wxg, Map<String, List<WorkerServiceCategoryDetail>> wxgCategoryTypeRecs,
                            SysDictRef sysDictRef, String code, String type, WorkerBrandAccount workerBrandAccount,
                            List<String> workerServiceCategoryDetailList) {
        Boolean include = Boolean.FALSE;
        // 看师傅是否已有（服务类型 INSTALL=安装 REPAIR=维修  DELIVERY=配送）对应的大类信息 如有不做任何处理
        if (wxgCategoryTypeRecs !=null && wxgCategoryTypeRecs.size()>0){
            if (wxgCategoryTypeRecs.containsKey(code)){
                for (WorkerServiceCategoryDetail category : wxgCategoryTypeRecs.get(code)){
                    if (category.getMainId().equals(sysDictRef.getDictCode())){
                        include = Boolean.TRUE;
                        break;
                    }
                }
            }
        }

        if (!include){
            // 新增
            // 看 worker_service_category 有无数据，无数据新增
            if (wxgCategoryTypeRecs ==null || wxgCategoryTypeRecs.size()<1 || !wxgCategoryTypeRecs.containsKey(code) ){
                WorkerServiceCategory wsc = new WorkerServiceCategory();
                wsc.setId(IdWorker.getIdStr());
                wsc.setWorkerId(workerBrandAccount.getWorkerId());
                wsc.setWebsitId(workerBrandAccount.getWebsitId());
                wsc.setWebsitWorkerId(workerBrandAccount.getWebsitWorkerId());
                wsc.setServiceCategoryId(sysDict.getDictCode());
                wsc.setServiceCategoryName(sysDict.getDictValue());
                wsc.setFlag(type);
                wsc.setType(code);
                wsc.setCreateTime(new Date());
                wscList.add(wsc);

                // WorkerServiceCategoryDetail 新增
                WorkerServiceCategoryDetail wscd = new WorkerServiceCategoryDetail();
                wscd.setId(IdWorker.getIdStr());
                wscd.setWorkerServiceCategoryId(wsc.getId());
                wscd.setWorkerId(workerBrandAccount.getWorkerId());
                wscd.setWebsitId(workerBrandAccount.getWebsitId());
                wscd.setWebsitWorkerId(workerBrandAccount.getWebsitWorkerId());
                wscd.setServiceCategoryId(sysDict.getDictCode());
                wscd.setServiceCategoryName(sysDict.getDictValue());
                wscd.setFlag(type);
                wscd.setType(code);
                wscd.setMainId(sysDictRef.getDictCode());
                wscd.setMainName(sysDictRef.getDictValue());
                wscd.setCreateTime(new Date());

                wscdList.add(wscd);

                workerServiceCategoryDetailList.add(workerBrandAccount.getWebsitWorkerId());

            } else {
                // WorkerServiceCategoryDetail 新增
                WorkerServiceCategoryDetail wscd = new WorkerServiceCategoryDetail();
                wscd.setId(IdWorker.getIdStr());
                wscd.setWorkerServiceCategoryId(wxgCategoryTypeRecs.get(code).get(0).getServiceCategoryId());
                wscd.setWorkerId(workerBrandAccount.getWorkerId());
                wscd.setWebsitId(workerBrandAccount.getWebsitId());
                wscd.setWebsitWorkerId(workerBrandAccount.getWebsitWorkerId());
                wscd.setServiceCategoryId(sysDict.getDictCode());
                wscd.setServiceCategoryName(sysDict.getDictValue());
                wscd.setFlag(type);
                wscd.setType(code);
                wscd.setMainId(sysDictRef.getDictCode());
                wscd.setMainName(sysDictRef.getDictValue());
                wscd.setCreateTime(new Date());
                wscdList.add(wscd);
                workerServiceCategoryDetailList.add(workerBrandAccount.getWebsitWorkerId());
            }
        }
    }
}
